﻿#include <iostream> 
#include <winsock.h> 
#pragma comment( lib, "ws2_32.lib" ) 
using namespace std;

void main(void) {
    WSAData wsaData;
    SOCKET sock = NULL;
    SOCKADDR_IN addrSender;
    try {

        if (WSAStartup(MAKEWORD(2, 2), &wsaData) != 0) {
            throw WSAGetLastError();
        }

        sock = socket(AF_INET, SOCK_DGRAM, 0);
        if (sock == INVALID_SOCKET) {
            throw WSAGetLastError();
        }

        BOOL bEnable = TRUE;
        if (setsockopt(sock, SOL_SOCKET, SO_BROADCAST, (char*)&bEnable, sizeof(bEnable)) == SOCKET_ERROR) {
            throw WSAGetLastError();
        }
        memset((void*)&addrSender, 0, sizeof(SOCKADDR));
        addrSender.sin_family = AF_INET;
        //addrSender.sin_port = htons(9000);
        addrSender.sin_port = htons(9901);
        addrSender.sin_addr.s_addr = htonl(INADDR_BROADCAST);

        char buf[1024] = { 0, };
        while (1)
        {
            cin >> buf;
            if (sendto(sock, buf, strlen(buf), 0, (SOCKADDR*)&addrSender, sizeof(SOCKADDR)) == SOCKET_ERROR) {
                throw WSAGetLastError();
            }
        }
    }
    catch (int& ex) {
        cout << "Error Code: " << ex << endl;
    }
    closesocket(sock);
    WSACleanup();
}